package nstautil

import (
	"fmt"
	"net"
	"time"
)

// ConnectionTest tries to open a tcp connection
func ConnectionTest(host string, port int) bool {
	timeout := time.Second
	conn, err := net.DialTimeout("tcp", fmt.Sprintf("%s:%d", host, port), timeout)
	if err != nil {
		return false
	}
	if conn != nil {
		_ = conn.Close()
		return true
	}
	return false
}

func DynamicPort() (int, error) {
	addr, err := net.ResolveTCPAddr("tcp", "localhost:0")
	if err != nil {
		return 0, err
	}

	l, err := net.ListenTCP("tcp", addr)
	if err != nil {
		return 0, err
	}
	if err := l.Close(); err != nil {
		return 0, err
	}
	return l.Addr().(*net.TCPAddr).Port, nil
}
